
//description and parameters for Objekjen shape macros

// makes a plane, shown with mesh of pov triangles
//j_plane()

// makes a plane, shown with pov polygon primative
//p_plane()

// makes a box, shown with mesh of pov triangles
//j_box()

// makes a box, shown with pov box primative
//p_box()

// makes a n-gon shape, shown with mesh of pov triangles
//     scaler     scaler in degrees
//    segments,   arc 
//j_gon(segs,     arc)


// makes a cone, shown with mesh of pov triangles
//       scaler   vector       scaler        scaler    scaler in degrees
//       basepoint, toppoint, baseradius, segments,    arc
//j_cone(baspnt,    toppnt,      brad,      segs,      arc)  


// makes a cone, shown with pov cone primative 
//        scaler     scaler     scaler
//       basepoint  toppoint  baseradius
//p_cone(baspnt,    toppnt,     brad) 


// makes a cylinder, shown with mesh of pov triangles
//      scaler     vector    scaler      scaler     scaler    scaler in degrees
//    basepoint, toppoint, topradius,  baseradius, segments,   arc
//j_cyl(baspnt,   toppnt,    trad,        brad,      segs,     arc)  


// makes a cylinder, shown with pov cylinder primative
//      scaler     scaler    scaler
//     basepoint toppoint baseradius 
//p_cyl(baspnt,   toppnt,   brad) 

//     scaler      vector     scaler     scaler       scaler     deg      scaler          scaler
//     basepoint, toppoint,  topradius, baseradius,  segments,   arc,  topinnerradius,  baseinnerradius 
//j_tub(baspnt,    toppnt,    trad,      brad,         segs,     arc,    tinrad,          binrad)  
 

///makes a sor tube of segments, defined by function or inverse function
// swap order of func1 with func2 for inverse function

//       function  function     scaler        scaler           scaler         scaler       scaler       0 or 1      0 or 1  
//        func1,    func2,    baseradius,   heittmultiplyer, stretchvalue,  segments,    tsegments,   closedtop,   closbtm 
//k_ifsor(func1,    func2,       brad,         htmlt,            stv,         segs,        tsegs,       klostp,    klosbtm)  
  

///makes a sor tube of segments, defined by function or inverse function
//swap order of f1 with f2 for inverse function
// oldr method, less smooth results than k_ifsor

//       function  function      scaler        scaler           scaler         scaler       scaler       0 or 1      0 or 1  
//        func1,    func2,     baseradius,   heittmultiplyer, stretchvalue,  segments,    tsegments,   closedtop,   closbtm 
//j_ifsor(func1,    func2,        brad,         htmlt,            stv,          segs,        tsegs,     klostp,      klosbtm)  
  

//   makes a dome, shown with mesh of pov triangles
//      scaler       scaler      scaler       0 or 1
//   baseradius, segments, meridians,  closbtm
//j_dom(brad,     segs,     mrds,      closbtm)  


// makes a dome, shown with pov sphere primative, differenced with pov box primative
// or clipped by pov box primative

//      scaler       0 or 1
//     baseradius  closedbottom
//p_dom(brad,        closbtm)
                            

// makes a sphere, shown with mesh of pov triangles                           
//     scaler      scaler     scaler
//   baseradius, segments,   meridians
//j_sfr(brad,       segs,      mrds)  


// makes a sphere, shown with pov sphere primative
//      scaler
//     baseradius
//p_sfr(brad)

// makes a capsule shaped structure, shown with a mesh of pov triangles

//          scaler       scaler     scaler
//          baseradius, segments,  meridians
// j_piltub(bsrad,       segz,       mrdz)

// makes a capsule shaped structure, shown with a union of 2 pov sphere primatives, and
// a pov cylinder primative
 
//           scaler
//         baseradius
// p_piltub(bsrad)


// default transform
// tf(<1,1,1>, <0,0,0>, <0,0,0>)

//notes:

//use k_ifsor like:
//
//#declare f1 = function(a){a};
//#declare f2 = function(a){a*a};
//mkobjgrp("parabola")
//k_ifsor(f1,    f2,       1.0,         1.0,           3,         prez,        prez,       0,    0)  
